//package org.javalobby.apps.whiteboard.server;

import java.net.*;
import java.io.*;
import java.util.*;

class ServerMessageListener extends Thread
{	public ServerMessageListener(Socket s, ServerHistory h, ReportInterface r)
	{	socket = s;
		history = h;
		report = r;
		clientName = socket.getInetAddress().getHostName();
		if ( report != null )
			report.logAction("Connect: "+clientName);
	}

	public void run()
	{	int last = 0;
	LOOP:
		try
		{   ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
			ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
			InputStreamReader in_test = new InputStreamReader(socket.getInputStream());
			do
			{	synchronized(history)
				{	int i;
					for ( i = last; i < history.getCount(); i++ )
					out.writeObject(history.getMessage(i));
					last = i;
				}
				if ( in_test.ready() )
				{	Object obj = in.readObject();
					if ( obj instanceof Message )
					{	Message msg = (Message)obj;
//						if ( obj instanceof Goodbye )
//						{	socket.close();
//							break LOOP;
//						} else
						if ( msg instanceof Hello )
						{	clientName = msg.getAlias();
							if ( report != null )
								report.logUser(clientName);
						}
						else if ( msg instanceof Message )
						{	msg.setTimestamp(new Date());
							synchronized(history)
							{	history.addMessage(msg);
							}
						}
					}
				}
				sleep(100);
			}
			while ( true );
		}
		catch (Exception e)
		{	if ( report != null )
				report.logError("Error(3): "+e);
		}
	}

	private String clientName;
	private Socket socket;
	private ServerHistory history;
	private ReportInterface report;
}
