//package org.javalobby.apps.whiteboard.dialogs;

import java.awt.*;
import java.awt.event.*;
//import org.javalobby.apps.whiteboard.tools.*;

public class Toolbar extends Frame
	implements ActionListener, MouseListener
{	public Toolbar()
	{	addWindowListener(new WindowAdapter()
			{	public void windowClosing(WindowEvent evt)
				{	Toolbar.this.setVisible(false);
				}
			});
		setTitle("Toolbar: " + tool);
		Panel p = new Panel();
		p.setLayout(new GridLayout(3,2));
		addTool(new Button("Line"), p);
		addTool(new Button("Box"), p);
		addTool(new Button("Oval"), p);
		addTool(new Button("Text"), p);
		label = new Label("Font", Label.CENTER);
		addTool(label, p);
		addTool(new Canvas()
			{	public void paint(Graphics g)
				{	g.setColor(color);
					Dimension d = getSize();
					g.fillRect(0, 0, d.width, d.height);
					g.setColor(Color.black);
					g.drawRect(0, 0, d.width-1, d.height-1);
				}
			}, p);
		add(p, "Center");
		isFilled = new Checkbox("Filled", false);
		add(isFilled, "South");
		setSize(120, 150);
	}

	private void addTool(Component component, Container container)
	{	if ( component instanceof Button )
		{	Button b = (Button)component;
			b.addActionListener(this);
		}
		else
			component.addMouseListener(this);
		container.add(component);
	}

	public Drawing getDrawing(Point p1, Point p2)
	{	if ( tool.equals("Line") )
			return new Line(color, p1, p2);
		if ( tool.equals("Box") )
			return new Box(color, isFilled.getState(), p1, p2);
		if ( tool.equals("Text") )
			return new Text(color, p1, "message", label.getFont());
		if ( tool.equals("Oval") )
			return new Oval(color, isFilled.getState(), p1, p2);
		return null;
	}

	public boolean isSinglePoint()
	{	return tool.equals("Text");
	}

	public void actionPerformed(ActionEvent evt)
	{	tool = evt.getActionCommand();
		setTitle(tool);
	}

	public void mouseEntered(MouseEvent evt) {}
	public void mouseExited(MouseEvent evt) {}
	public void mousePressed(MouseEvent evt) {}
	public void mouseReleased(MouseEvent evt) {}

	public void mouseClicked(MouseEvent evt)
	{	if ( evt.getComponent() instanceof Canvas )
		{	ColorDialog dia = new ColorDialog(this, color);
			dia.show();
			color = dia.getColorResult();
			dia.dispose();
		}
		else if ( evt.getComponent() instanceof Label )
		{	FontDialog dia = new FontDialog(this, label.getFont());
			dia.show();
			label.setFont(dia.getFontResult());
			dia.dispose();
		}
		repaint();
	}

	private Color color = Color.black;
	private Label label = null;
	private String tool = "Line";
	private Checkbox isFilled = null;
}
