/* MultiView.java
 *
 * Copyright (c) 2000 Sean Walton and Macmillan Publishers.  Use may be in
 * whole or in part in accordance to the General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

/*****************************************************************************/
/*** MultiView.java                                                       ***/
/***                                                                       ***/
/*****************************************************************************/
import java.awt.*;
import java.awt.event.*;

public class MultiView extends Frame
	implements WindowListener
{
	public void windowActivated(WindowEvent e)		{}
	public void windowClosed(WindowEvent e)			{}
	public void windowClosing(WindowEvent e)		{System.exit(0);}
	public void windowDeactivated(WindowEvent e)	{}
	public void windowDeiconified(WindowEvent e)	{}
	public void windowIconified(WindowEvent e)		{}
	public void windowOpened(WindowEvent e)			{}

	public MultiView(String title, Image img, int row, int col)
	{
		super(title);
		width = img.getWidth(this);
		height = img.getHeight(this);
		setSize(width*cols, height*rows);
		addWindowListener(this);
		pane = new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
		pane.setSize(width*cols,height*rows);
		Panel p = new Panel(null);
		pane.add(p);
		tile = new ImageTile[rows][cols];
		for ( int r = 0; r < rows; r++ )
			for ( int c = 0; c < cols; c++ )
			{
				tile[r][c] = new ImageTile(width,height);
				tile[r][c].setSize(width, height);
			}
		tile[row][col].setImage(img);
		for ( int r = 0; r < rows; r++ )
			for ( int c = 0; c < cols; c++ )
			{
				p.add(tile[r][c]);
				tile[r][c].setLocation(c*width, r*height);
			}
		add(pane);
	}

	public void setImage(Image img, int row, int col)
	{
		tile[row][col].setImage(img);
	}

	public static final int rows=4;
	public static final int cols=4;
	ScrollPane pane;
	ImageTile tile[][];
	int width, height;
}