/* ViewServer.java
 *
 * Copyright (c) 2000 Sean Walton and Macmillan Publishers.  Use may be in
 * whole or in part in accordance to the General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

/*****************************************************************************/
/*** ViewServer.java                                                       ***/
/***                                                                       ***/
/*****************************************************************************/
import java.util.zip.*;
import java.io.*;
import java.awt.*;
import com.sun.image.codec.jpeg.*;

public class ViewServer extends Thread
{
	public void run()
	{	int row=0, col=0;
		int rowwidth=480/MultiView.rows, colwidth=640/MultiView.cols;
		history = new NetImage[MultiView.rows][MultiView.cols];

		while (true)
		{
			try
			{
//				if ( VMeeting.chview.getState() != true )
//					sleep(1000);
//				else
				{
					Robot robot = new Robot();
					Rectangle r = new Rectangle(col*colwidth, row*rowwidth, colwidth, rowwidth);
					NetImage bi = NetImage.createNetImage(robot.createScreenCapture(r));
					if ( !bi.equals(history[row][col]) )
					{
						history[row][col] = bi;
						ByteArrayOutputStream ob = new ByteArrayOutputStream();
						GZIPOutputStream oz = new GZIPOutputStream(ob);
						ObjectOutputStream o = new ObjectOutputStream(oz);
						o.writeObject(VMeeting.name.getText());
						Integer ival = new Integer(1);
						o.writeObject(ival);
						ival = new Integer(row);
						o.writeObject(ival);
						ival = new Integer(col);
						o.writeObject(ival);
						JPEGImageEncoder jpeg = JPEGCodec.createJPEGEncoder(o);
						jpeg.encode(bi);
						o.flush();
						oz.finish();
						VMeeting.transmitMessage(ob.toByteArray(), "");
					}
					sleep(50);
					if ( ++col >= MultiView.cols )
					{
						col = 0;
						if ( ++row >= MultiView.rows )
							row = 0;
					}
				}
			}
			catch (Exception err)
			{
				System.err.println("Main: "+err.toString());
			}
		}
	}

	NetImage history[][];
}
