/* recvmsg.c
 *
 * Copyright (c) 2000 Sean Walton and Macmillan Publishers.  Use may be in
 * whole or in part in accordance to the General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

/*****************************************************************************/
/*** recvmsg.c                                                             ***/
/***                                                                       ***/
/*****************************************************************************/

#include <stdio.h>
#include <resolv.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include "panic.h"

#define MSGS	16

int main()
{	int sd, bytes;
	char buffer[MSGS][1000];
	int i, cnt=0;
	struct sockaddr_in addr;
	struct iovec io[MSGS];
	struct msghdr msg;

	sd = socket(PF_INET, SOCK_DGRAM, 0);
	bzero(&addr, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(8080);
	addr.sin_addr.s_addr = INADDR_ANY;
	if ( bind(sd, &addr, sizeof(addr)) != 0 )
		panic("Can't bind address!\n");

	bzero(&addr, sizeof(addr));
	msg.msg_name = &addr;
	msg.msg_namelen = sizeof(addr);
	for ( i = 0; i < MSGS; i++ )
	{
		io[i].iov_base = buffer[i];
		io[i].iov_len = sizeof(buffer[i]);
	}
	msg.msg_iov = io;
	msg.msg_iovlen = MSGS;
	if ( (bytes = recvmsg(sd, &msg, 0)) < 0 )
		panic("recvmsg");
	for ( i = 0; i < msg.msg_iovlen; i++ )
		printf("msg #%d[%d bytes]: \"%s\"\n", i, bytes, buffer[i]);
	close(sd);
	return 0;
}