/* rpclist_client.c
 *
 * Copyright (c) 2000 Sean Walton and Macmillan Publishers.  Use may be in
 * whole or in part in accordance to the General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

/*****************************************************************************/
/*** rpclist_client.c                                                       ***/
/***                                                                       ***/
/*****************************************************************************/

/*
 * This is sample code generated by rpcgen.
 * These are only templates and you can use them
 * as a guideline for developing your own functions.
 */

#include "rpclist.h"


void
listprog_1(char *host, char *msg)
{	CLIENT *clnt;
	NodeUnion  *result_1;
	TNode list;

#ifndef	DEBUG
	clnt = clnt_create (host, LISTPROG, LISTVERSION, "udp");
	if (clnt == NULL) {
		clnt_pcreateerror (host);
		exit (1);
	}
#endif	/* DEBUG */

	result_1 = getlist_1(&msg, clnt);
	if (result_1 == (NodeUnion *) NULL)
	{
		clnt_perror (clnt, "call failed");
	}

	if ( result_1->Err == 0 )
	{
		for ( list = result_1->NodeUnion_u.NameList; list != NULL; list = list->Next )
			printf("%s\n", list->Name);
	}

#ifndef	DEBUG
	clnt_destroy (clnt);
#endif	 /* DEBUG */
}


int
main (int argc, char *argv[])
{	char *host;
	char *msg;

	if (argc != 3)
	{
		printf ("usage: %s <server_host> <msg>\n", argv[0]);
		exit (1);
	}
	host = argv[1];
	msg = argv[2];
	listprog_1(host, msg);

	exit(0);
}
