/* rpcps_client.c
 *
 * Copyright (c) 2000 Sean Walton and Macmillan Publishers.  Use may be in
 * whole or in part in accordance to the General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

/*****************************************************************************/
/*** rpcps_client.c                                                        ***/
/***                                                                       ***/
/*****************************************************************************/

/*
 * This is sample code generated by rpcgen.
 * These are only templates and you can use them
 * as a guideline for developing your own functions.
 */

#include "rpcps.h"


void
rpcps_1(char *host, char *args)
{	TRow row;
	TTable table;
	CLIENT *clnt;
	TableResult  *result_1;

#ifndef	DEBUG
	clnt = clnt_create (host, RPCPS, PSVERSION, "udp");
	if (clnt == NULL) {
		clnt_pcreateerror (host);
		exit (1);
	}
#endif	/* DEBUG */

	result_1 = getps_1(&args, clnt);
	if (result_1 == (TableResult *) NULL)
	{
		clnt_perror (clnt, "call failed");
	}

	if ( result_1->Err == 0 )
	{
		table = result_1->TableResult_u.Table;
		for ( ; table != NULL; table = table->Next )
		{
			for ( row = table->Row; row != NULL; row = row->Next )
				printf("%s ", row->Field);
			printf("\n");
		}
	}

#ifndef	DEBUG
	clnt_destroy (clnt);
#endif	 /* DEBUG */
}


int
main (int argc, char *argv[])
{	char *host;
	char *args;

	if (argc != 3) {
		printf ("usage: %s <server_host> <ps-args>\n", argv[0]);
		exit (1);
	}
	host = argv[1];
	args = argv[2];
	rpcps_1 (host, args);
exit (0);
}
