//package org.javalobby.apps.whiteboard.dialogs;

import java.awt.*;
import java.awt.event.*;

public class Chatroom extends Frame
	implements ActionListener
{	public Chatroom(PipeInterface pi)
	{	this.pipe = pi;
		setTitle("Chatter Box");
		addWindowListener(new WindowAdapter()
			{ public void windowClosing(WindowEvent evt) { pipe.shutdown(); } });
		Panel p = new Panel();
		p.setBackground(SystemColor.control);
		p.setLayout(new FlowLayout());
		field = new TextField(50);
		p.add(field);
		Button b = new Button("Send!");
		b.addActionListener(this);
		p.add(b);
		add(p, "North");
		msgs = new TextArea();
		msgs.setEditable(false);
		add(msgs, "Center");
		setSize(500,300);
	}

	public void actionPerformed(ActionEvent evt)
	{	pipe.send(new Chat(field.getText())); 
		field.setText("");
	}

	public void addMsg(Chat msg)
	{	msgs.append(msg.getAlias()+" says:"+msg.getMsg()+"\n");
	}

	public void shutdown() {}

	private TextArea msgs;
	private TextField field;
	private PipeInterface pipe;
}

