//package org.javalobby.apps.whiteboard.dialogs;

import java.awt.*;
import java.awt.event.*;

public class ColorDialog extends Dialog
	implements ActionListener, AdjustmentListener
{	public ColorDialog(Frame parent, Color c)
	{	super(parent, "Color Dialog", true);
		color = c;
		Panel p = new Panel();
		p.setLayout(new GridLayout(3,3));

		//---Red
		p.add(new Label("Red:", Label.RIGHT));
		redScrollbar = addScrollbar(p, c.getRed());
		redLabel = new Label("("+c.getRed()+")", Label.CENTER);
		p.add(redLabel);

		//---Blue
		p.add(new Label("Blue:", Label.RIGHT));
		blueScrollbar = addScrollbar(p, c.getBlue());
		blueLabel = new Label("("+c.getBlue()+")", Label.CENTER);
		p.add(blueLabel);

		//---Green
		p.add(new Label("Green:", Label.RIGHT));
		greenScrollbar = addScrollbar(p, c.getGreen());
		greenLabel = new Label("("+c.getGreen()+")", Label.CENTER);
		p.add(greenLabel);
		add(p, "West");

		//---Sample
		sampleColor = new Canvas()
			{	public void paint(Graphics g)
				{	Dimension d = getSize();
					g.setColor(Color.black);
					g.drawRect(0, 0, d.width-1, d.height-1);
					g.setColor(color);
					g.fillRect(1, 1, d.width-2, d.height-2);
				}
			};
		sampleColor.setSize(75,75);
		p = new Panel();
		p.add(sampleColor);
		add(p, "East");

		//---Close
		p = new Panel();
		Button b = new Button("Done");
		b.addActionListener(this);
		p.add(b);
		add(p, "South");

		setSize(200,120);
	}
	
	private Scrollbar addScrollbar(Container container, int init)
	{	Scrollbar sb = new Scrollbar(Scrollbar.HORIZONTAL, init, 0, 0, 255);
		sb.setBlockIncrement(8);
		sb.setUnitIncrement(1);
		sb.addAdjustmentListener(this);
		container.add(sb);
		return sb;
	}

	public void actionPerformed(ActionEvent evt)
	{	setVisible(false);
	}

	public void adjustmentValueChanged(AdjustmentEvent evt)
	{	if ( evt.getAdjustable().equals(redScrollbar) )
			redLabel.setText("("+redScrollbar.getValue()+")");
		if ( evt.getAdjustable().equals(greenScrollbar) )
			greenLabel.setText("("+greenScrollbar.getValue()+")");
		if ( evt.getAdjustable().equals(blueScrollbar) )
			blueLabel.setText("("+blueScrollbar.getValue()+")");
		color = new Color(redScrollbar.getValue(), greenScrollbar.getValue(), blueScrollbar.getValue());
		sampleColor.repaint();
	}

	public Color getColorResult()
	{	return color;
	}

	private Color color = null;
	private Scrollbar redScrollbar = null;
	private Scrollbar blueScrollbar = null;
	private Scrollbar greenScrollbar = null;
	private Label redLabel = null;
	private Label blueLabel = null;
	private Label greenLabel = null;
	private Canvas sampleColor = null;
}
