//package org.javalobby.apps.whiteboard.dialogs;

import java.awt.*;
import java.awt.event.*;

public class FontDialog extends Dialog
	implements ActionListener, ItemListener
{	public FontDialog(Frame parent, Font font)
	{	super(parent, "Font Dialog", true);
		setSize(240, 170);
		Panel main = new Panel();
		main.setLayout(new FlowLayout());
		
		//---Style
		style = font.getStyle();
		Panel p = new Panel();
		p.setLayout(new GridLayout(2,1));
		bold = new Checkbox("Bold");
		bold.setState((style & Font.BOLD) == Font.BOLD);
		italics = new Checkbox("Italics");
		italics.setState((style & Font.ITALIC) == Font.ITALIC);
		bold.addItemListener(this);
		italics.addItemListener(this);
		p.add(bold);
		p.add(italics);
		main.add(p);

		//---Font names
		Panel p2 = new Panel();
		p2.setLayout(new GridLayout(2,1));
		fontNames = new Choice();
		fontNames.addItemListener(this);
		String[] fns = getToolkit().getFontList();
		for ( int i = 0; i < fns.length; i++ )
			fontNames.add(fns[i]);
		fontNames.select(font.getName());
		p2.add(fontNames);

		//---Font size
		size = font.getSize();
		p = new Panel();
		p.setLayout(new FlowLayout());
		Button b = new Button("+");
		b.setSize(15,18);
		b.addActionListener(this);
		p.add(b);
		fontSize = new Label("", Label.CENTER);
		fontSize.setText(Integer.toString(size));
		p.add(fontSize);
		b = new Button("-");
		b.setSize(15,18);
		b.addActionListener(this);
		p.add(b);
		p2.add(p);
		main.add(p2);

		//---Sample
		sampleString = new Label("Sample String", Label.CENTER)
			{	public void paint(Graphics g)
				{	super.paint(g);
					Dimension dim = getSize();
					g.drawRect(0, 0, dim.width-1, dim.height-1);
				}
			};
		sampleString.setSize(300,40);
		sampleString.setFont(font);
		main.add(sampleString);
		add(main);
		p = new Panel();
		b = new Button("Done");
		b.addActionListener(this);
		p.add(b);
		add(p, "South");
	}

	public void actionPerformed(ActionEvent evt)
	{	char cmd = evt.getActionCommand().charAt(0);
		if ( cmd == '+' )
			size++;
		else if ( cmd == '-' )
			size--;
		else
			setVisible(false);
		fontSize.setText(Integer.toString(size));
		sampleString.setFont(new Font(fontNames.getSelectedItem(), style, size));
		repaint();
	}

	public void itemStateChanged(ItemEvent evt)
	{	style = Font.PLAIN;
		if ( bold.getState() )
			style |= Font.BOLD;
		if (italics.getState() )
			style |= Font.ITALIC;
		sampleString.setFont(new Font(fontNames.getSelectedItem(), style, size));
		repaint();
	}

	public Font getFontResult()
	{	return sampleString.getFont();
	}

	private int style;
	private int size;
	private Checkbox bold;
	private Checkbox italics;
	private Choice fontNames;
	private Label fontSize;
	private Label sampleString;
}