//package org.javalobby.apps.whiteboard;

import java.io.*;
import java.net.*;
//import org.javalobby.apps.whiteboard.dialogs.*;

class Pipe extends Thread
	implements PipeInterface
{	public Pipe(Socket s, String alias)
	{	socket = s;
		this.alias = alias;
		try
		{	//---Note that the connection must be reverse to that of the server
			//---otherwise, deadlock will occur.
			out = new ObjectOutputStream(socket.getOutputStream());	
			in = new ObjectInputStream(socket.getInputStream());
//			if ( in == null  ||  out == null )
//				throw Exception("Can't create pipes!");
		}
		catch (Exception e)
		{	System.err.println("Error: "+e);
		}
		send(new Hello());
		chatroom = new Chatroom(this);
		whiteboard = new Whiteboard(this);
		chatroom.show();
		whiteboard.show();
	}

	public void run()
	{	try
		{	Object msg;
			do
			{	msg = in.readObject();
				if ( msg instanceof Chat )
					chatroom.addMsg((Chat)msg);
				else if ( msg instanceof Drawing )
					whiteboard.addMsg((Drawing)msg);
				else if ( msg instanceof Hello )
					hello = (Hello)msg;
				Thread.sleep(100);
			}
			while ( true );
		}
		catch (Exception e)
		{	System.err.println("Error: " + e);
		}
	}

	public void shutdown()
	{	send(new Goodbye(hello));
		chatroom.shutdown();
		chatroom.dispose();
		whiteboard.shutdown();
		whiteboard.dispose();
		stop();
	}

	public void send(Message msg)
	{	msg.setAlias(alias);
		try
		{	out.writeObject(msg);
		}
		catch (Exception e)
		{	System.err.println("Error: "+e);
		}
	}

	private Socket socket;
	private ObjectOutputStream out;
	private ObjectInputStream in;
	private Chatroom chatroom;
	private Whiteboard whiteboard;
	private Hello hello = null;
	private String alias;
}
