//package org.javalobby.apps.whiteboard.server;

import java.util.*;

public class ServerHistory extends Thread
{	public ServerHistory(ReportInterface report, int delay, long expiration)
	{	this.delay = delay;
		this.expiration = expiration;
		this.report = report;
		vector = new Vector();
	}

	public Object getMessage(int index)
	{	synchronized(vector)
		{	return vector.elementAt(index);
		}
	}

	public void addMessage(Object obj)
	{	if ( report != null )
			report.logMessage(obj);
		synchronized(vector)
		{	vector.addElement(obj);
		}
	}

	public int getCount()
	{	return vector.size();
	}

	public void run()
	{	while (true)
		{	synchronized(vector)
			{	int i = 0;
				while (i < vector.size())
				{	Object obj = vector.elementAt(i);
					Message msg = (Message)obj;
					long age = System.currentTimeMillis() - msg.getTimestamp().getTime();
					if ( age >= expiration )
					{	if (report != null )
							report.logAction("Expired: "+obj);
						vector.removeElementAt(i);
					}
					else
						i++;
				}
			}
			try {sleep(delay);}
			catch (Exception e) {}
		}
	}

	long delay=1000;
	long expiration=15*60*1000;
	Vector vector = null;
	ReportInterface report = null;
}
