/*
 * Copyright (c) 2000 Sean Walton and Macmillan Publishers.  Use may be in
 * whole or in part in accordance to the General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/
#include <sys/types.h>
#include <resolv.h>

/*-----------------------------------GetAddress.c-----------------------------------*/
int GetService(const char *service, const char *protocol);
int GetAddress(struct sockaddr_in *addr, const char *host, int port);
int GetAddressSvc(struct sockaddr_in *addr, const char *host, const char *service);

/*----------------------------------StreamSocket.c----------------------------------*/
int SocketClient(const char *host, int port);
int SocketClientSvc(const char *host, const char *service);
int SocketServer(int port, const char *iface);
int SocketServerSvc(const char* service, const char *iface);

/*---------------------------------DatagramSocket.c---------------------------------*/
int SocketDatagram(int port, const char *iface);
int JoinGroup(int sd, const char *group);
