//package org.javalobby.apps.whiteboard;

import java.io.*;
import java.net.*;
//import org.javalobby.apps.whiteboard.dialogs.*;

class Pipe extends Thread
	implements PipeInterface
{	public Pipe(Socket s)
	{	socket = s;
		try
		{	//---Note that the connection must be reverse to that of the server
			//---otherwise, deadlock will occur.
			out = new ObjectOutputStream(socket.getOutputStream());	
			in = new ObjectInputStream(socket.getInputStream());
//			if ( in == null  ||  out == null )
//				throw Exception("Can't create pipes!";
		}
		catch (Exception e)
		{	System.err.println("Error: "+e);
		}
		chatroom = new Chatroom(this);
		whiteboard = new Whiteboard(this);
		chatroom.show();
		whiteboard.show();
	}

	public void run()
	{	try
		{	Object msg;
			do
			{	msg = in.readObject();
				if ( msg instanceof String )
					chatroom.addMsg(((String)msg)+'\n');
				else if ( msg instanceof Drawing )
					whiteboard.addMsg((Drawing)msg);
				Thread.sleep(100);
			}
			while ( true );
		}
		catch (Exception e)
		{	System.err.println("Error: " + e);
		}
	}

	public void send(Object obj)
	{	try
		{	out.writeObject(obj);
		}
		catch (Exception e)
		{	System.err.println("Error: "+e);
		}
	}

	private Socket socket;
	private ObjectOutputStream out;
	private ObjectInputStream in;
	private Chatroom chatroom;
	private Whiteboard whiteboard;
}
