//package org.javalobby.apps.whiteboard.dialogs;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
//import org.javalobby.apps.whiteboard.tools.*;

class Whiteboard extends Frame
	implements MouseListener, MouseMotionListener
{	public Whiteboard(PipeInterface pipe)
	{	this.pipe = pipe;
		testDraw = null;
		History = new Vector();
		addWindowListener(new WindowAdapter()
			{	public void windowClosing(WindowEvent evt) { System.exit(0); } });
		tools = new Toolbar();
		tools.show();
		canvas = new Canvas()
			{	public void paint(Graphics g)
				{	for ( int i = 0; i < History.size(); i++ )
					{	Drawing d = (Drawing)(History.elementAt(i));
						d.draw(g);
					}
					if ( testDraw != null )
						testDraw.draw(g);
				}
			};
		canvas.addMouseListener(this);
		canvas.addMouseMotionListener(this);
		add(canvas);
		setSize(400,300);
	}

	public void addMsg(Drawing d)
	{	History.addElement(d);
		canvas.repaint();
	}

	public void mouseEntered(MouseEvent evt) {}
	public void mouseExited(MouseEvent evt) {}
	public void mouseClicked(MouseEvent evt) 
	{	if ( tools.isSinglePoint() )
			pipe.send(tools.getDrawing(evt.getPoint(), evt.getPoint()));
	}

	public void mousePressed(MouseEvent evt) 
	{	firstPoint = evt.getPoint();
	}

	public void mouseReleased(MouseEvent evt)
	{	if ( lastPoint != null )
			pipe.send(tools.getDrawing(firstPoint, lastPoint));
		testDraw = null;
		lastPoint = null;
	}

	public void mouseMoved(MouseEvent evt) {}
	public void mouseDragged(MouseEvent evt) 
	{	lastPoint = evt.getPoint();
		testDraw = tools.getDrawing(firstPoint, lastPoint);
		canvas.repaint();
	}

	private Vector History;
	private Drawing testDraw;
	private Canvas canvas;
	private Toolbar tools;
	private Point firstPoint, lastPoint;
	private PipeInterface pipe;
}
