//package org.javalobby.apps.whiteboard;

import java.net.*;
import java.io.*;
import java.util.*;

class WhiteboardServer
{	public WhiteboardServer(int port)
	{	try
		{	server = new ServerSocket(port);
			if ( server == null )
			{	throw new Exception("Can't access port #"+port+"!");
			}
		}
		catch (Exception e)
		{	System.err.println("Error(1): "+e);
			System.exit(1);
		}
	}

	public void getConnection()
	{	while (true)
		{	try
			{	Socket s = server.accept();
				Thread t = new MessageListener(s);
				t.start();
			}
			catch (Exception e)
			{	System.err.println("Error(2): "+e);
			}
		}
	}

	public static void main(String[] args)
	{	WhiteboardServer s = new WhiteboardServer(8189);
		s.getConnection();
	}

	ServerSocket server = null;
}

class MessageListener extends Thread
{	public MessageListener(Socket s)
	{	socket = s;
		clientName = socket.getInetAddress().getHostName();
		System.out.println("Connect: "+clientName);
	}

	public void run()
	{	int last = 0;
		Object msg;
	LOOP:
		try
		{
			ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
			ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
			InputStreamReader in_test = new InputStreamReader(socket.getInputStream());
			do
			{	
				synchronized(history)
				{	int i;
					for ( i = last; i < history.size(); i++ )
					out.writeObject(history.elementAt(i));
					last = i;
				}
				if ( in_test.ready() )
				{	msg = in.readObject();
					if ( msg instanceof String )
						if ( ((String)msg).equals("bye") )
						{	socket.close();
							break LOOP;
						}
					synchronized(history)
					{	if ( msg instanceof String )
							history.addElement(clientName+": "+msg);
						else
							history.addElement(msg);
					}
				}
				sleep(100);
			}
			while ( true );
		}
		catch (Exception e)
		{	System.err.println("Error(3): "+e);
		}
	}

	private String clientName;
	private Socket socket;
	private static Vector history = new Vector();
}