//package org.javalobby.apps.whiteboard;

import java.net.*;
import java.io.*;
import java.util.*;
//import org.javalobby.apps.whiteboard.server.*;

class WhiteboardServer
{	public WhiteboardServer(int port)
	{	history = new ServerHistory(report, 1000,15*60*1000);
		try
		{	server = new ServerSocket(port);
			if ( server == null )
			{	throw new Exception("Can't access port #"+port+"!");
			}
			history.start();
		}
		catch (Exception e)
		{	System.err.println("Error(1): "+e);
			System.exit(1);
		}
	}

	public void getConnection()
	{	while (true)
		{	try
			{	Socket s = server.accept();
				Thread t = new ServerMessageListener(s, history, report);
				t.start();
			}
			catch (Exception e)
			{	if ( report != null )
					report.logError("Error(2): "+e);
			}
		}
	}

	private static void getParams(String[] args)
	{	int i = 0;
		while ( i < args.length )
		{	if ( args[i].equals("-port") )
			{	portnum = Integer.getInteger(args[i+1]).intValue();
				i += 2;
			}
			else if ( args[i].equals("-status-gui") )
			{	report = new ServerReport_GUI();
				i++;
			}
			else if ( args[i].equals("-status-text") )
			{	report = new ServerReport_Text();
				i++;
			}
			else
			{	System.err.println("Unknown argument: \""+args[i++]+"\"");
			}
		}
	}

	public static void main(String[] args)
	{	getParams(args);
		WhiteboardServer s = new WhiteboardServer(portnum);
		s.getConnection();
	}

	private static int portnum = 8189;
	private static ReportInterface report = null;
	private ServerSocket server = null;
	private ServerHistory history = null;
}
